(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("Premiere", [], factory);
	else if(typeof exports === 'object')
		exports["Premiere"] = factory();
	else
		root["Premiere"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var Api_1 = __webpack_require__(1);
	exports.Api = Api_1.default;
	var Cache_1 = __webpack_require__(2);
	exports.Cache = Cache_1.default;
	var Model_1 = __webpack_require__(29);
	exports.Model = Model_1.default;
	var Store_1 = __webpack_require__(30);
	exports.Store = Store_1.default;
	var api = new Api_1.default();
	exports.api = api;
	//# sourceMappingURL=index.js.map

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var Cache_1 = __webpack_require__(2);
	var axios_1 = __webpack_require__(3);
	/**
	 * An Api instance defines the properties to consume a restful api
	 */
	var Api = (function () {
	    function Api(properties) {
	        if (properties === void 0) { properties = {}; }
	        /**
	         * Cache instance attached to the Api
	         */
	        this.cache = new Cache_1.default(this);
	        Object.assign(this, properties);
	    }
	    /**
	     * Get path.
	     * This is very useful if you have one Api for each model for example
	     * Eg. books (base + path would look like http://my-api.com/books)
	     * @type {string}
	     */
	    Api.prototype.path = function () {
	        return '';
	    };
	    /**
	     * Get api base
	     * @return {string}
	     */
	    Api.prototype.resolveBase = function () {
	        var self = this.constructor;
	        return this.base || self.base || Api.base;
	    };
	    /**
	     * Get api headers
	     * @return {Hash<string>}
	     */
	    Api.prototype.resolveHeaders = function () {
	        var self = this.constructor;
	        return this.headers || self.headers || Api.headers;
	    };
	    /**
	     * Get base url (base + path)
	     * @returns {string}
	     */
	    Api.prototype.baseUrl = function () {
	        var base = this.resolveBase();
	        if (!base.endsWith('/')) {
	            base += '/';
	        }
	        var path = this.path();
	        if (!path.endsWith('/')) {
	            path += '/';
	        }
	        return base + path;
	    };
	    /**
	     * Check if instance is using cache
	     */
	    Api.prototype.isUsingCache = function () {
	        return this.useCache || this.constructor.useCache || Api.useCache;
	    };
	    /**
	     * Check if instance is using promise cache
	     */
	    Api.prototype.isUsingPromiseCache = function () {
	        return this.usePromiseCache || this.constructor.usePromiseCache || Api.usePromiseCache;
	    };
	    /**
	     * Get http requester
	     * @return {AxiosInstance}
	     */
	    Api.prototype.http = function () {
	        return axios_1.default.create({
	            baseURL: this.baseUrl(),
	            headers: this.resolveHeaders()
	        });
	    };
	    /**
	     * Cache promise by name, so it doesn't get executed again before the result comes back
	     */
	    Api.prototype.cachePromise = function (name, fn) {
	        var _this = this;
	        if (!this.isUsingPromiseCache()) {
	            return new Promise(fn);
	        }
	        var cached = this.cache.getPromise(name);
	        if (cached) {
	            return cached;
	        }
	        var promise = new Promise(fn);
	        this.cache.setPromise(name, promise);
	        var destroyCallback = function () {
	            _this.cache.destroyPromise(name);
	        };
	        promise.then(destroyCallback, destroyCallback);
	        return promise;
	    };
	    /**
	     * Add JWT authorization header for a given token
	     */
	    Api.setJwtToken = function (token, target) {
	        if (target === void 0) { target = this.headers; }
	        target['Authorization'] = "Bearer " + token;
	    };
	    /**
	     * Add JWT authorization header for a given token
	     */
	    Api.prototype.setJwtToken = function (token) {
	        var self = this.constructor;
	        self.setJwtToken(token, this.headers);
	    };
	    /**
	     * Remove JWT authorization header
	     */
	    Api.removeJwtToken = function (target) {
	        if (target === void 0) { target = this.headers; }
	        delete target['Authorization'];
	    };
	    /**
	     * Remove JWT authorization header
	     */
	    Api.prototype.removeJwtToken = function () {
	        var self = this.constructor;
	        self.removeJwtToken(this.headers);
	    };
	    /**
	     * Add CSRF token to static header
	     */
	    Api.setCsrfToken = function (token, target) {
	        if (target === void 0) { target = this.headers; }
	        target['X-CSRF-Token'] = token;
	    };
	    Api.prototype.setCsrfToken = function (token) {
	        var self = this.constructor;
	        self.setCsrfToken(token, this.headers);
	    };
	    /**
	     * Remove CSRF token from static header
	     */
	    Api.removeCsrfToken = function (target) {
	        if (target === void 0) { target = this.headers; }
	        delete target['X-CSRF-Token'];
	    };
	    /**
	     * Remove CSRF token from header
	     */
	    Api.prototype.removeCsrfToken = function () {
	        var self = this.constructor;
	        self.removeCsrfToken(this.headers);
	    };
	    return Api;
	}());
	/**
	 * Default headers
	 */
	Api.headers = {};
	/**
	 * Default use cache value
	 */
	Api.useCache = true;
	/**
	 * Default use promise cache value
	 */
	Api.usePromiseCache = true;
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.default = Api;
	//# sourceMappingURL=Api.js.map

/***/ },
/* 2 */
/***/ function(module, exports) {

	"use strict";
	/**
	 * The cache is responsible for storing objects, lists and promises
	 * The goal is to optimize the application speed and network usage
	 */
	var Cache = (function () {
	    function Cache(api) {
	        /**
	         * The list of objects cached.
	         */
	        this.objects = {};
	        /**
	         * The list of lists of object cached.
	         */
	        this.lists = {};
	        /**
	         * The list of promises cached.
	         */
	        this.promises = {};
	        this.api = api;
	    }
	    /**
	     * Get key from value
	     */
	    Cache.resolveKey = function (value) {
	        if (typeof value === 'object') {
	            return value.key().toString();
	        }
	        return value.toString();
	    };
	    /**
	     * Check if caching is enabled
	     */
	    Cache.prototype.enabled = function () {
	        return !this.api || this.api.isUsingCache();
	    };
	    /**
	     * Check if promise caching is enabled
	     */
	    Cache.prototype.promiseEnabled = function () {
	        return !this.api || this.api.isUsingPromiseCache();
	    };
	    /**
	     * Get object
	     */
	    Cache.prototype.get = function (value) {
	        if (this.enabled()) {
	            return this.objects[value.toString()];
	        }
	    };
	    /**
	     * Get object by property value
	     */
	    Cache.prototype.where = function (property, value) {
	        var _this = this;
	        if (this.enabled()) {
	            var values = Object.keys(this.objects).map(function (key) { return _this.objects[key]; });
	            return values.find(function (object) {
	                return object[property] === value;
	            });
	        }
	    };
	    /**
	     * Set object
	     */
	    Cache.prototype.set = function (value, clearLists) {
	        var _this = this;
	        if (clearLists === void 0) { clearLists = true; }
	        if (Array.isArray(value)) {
	            var list = value;
	            return list.map(function (it) { return _this.set(it, clearLists); });
	        }
	        var object = value;
	        if (this.enabled()) {
	            this.objects[object.key()] = object;
	            if (clearLists) {
	                this.lists = {};
	            }
	        }
	        return object;
	    };
	    /**
	     * Remove object
	     */
	    Cache.prototype.destroy = function (value) {
	        var self = this.constructor;
	        delete this.objects[self.resolveKey(value)];
	        this.lists = {};
	    };
	    /**
	     * Get list by name
	     */
	    Cache.prototype.getList = function (name) {
	        if (this.enabled()) {
	            return this.lists[name];
	        }
	    };
	    /**
	     * Set list by name
	     */
	    Cache.prototype.setList = function (name, list) {
	        if (this.enabled()) {
	            this.lists[name] = list;
	        }
	        return list;
	    };
	    Cache.prototype.destroyList = function (name) {
	        delete this.lists[name];
	    };
	    /**
	     * Get promise by name
	     */
	    Cache.prototype.getPromise = function (name) {
	        if (this.promiseEnabled()) {
	            return this.promises[name];
	        }
	    };
	    /**
	     * Set promise by name
	     */
	    Cache.prototype.setPromise = function (name, promise) {
	        if (this.promiseEnabled()) {
	            return this.promises[name] = promise;
	        }
	        return promise;
	    };
	    /**
	     * Destroy promise by name
	     */
	    Cache.prototype.destroyPromise = function (name) {
	        delete this.promises[name];
	    };
	    return Cache;
	}());
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.default = Cache;
	//# sourceMappingURL=Cache.js.map

/***/ },
/* 3 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = __webpack_require__(4);

/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var utils = __webpack_require__(5);
	var bind = __webpack_require__(6);
	var Axios = __webpack_require__(7);
	var defaults = __webpack_require__(8);
	
	/**
	 * Create an instance of Axios
	 *
	 * @param {Object} defaultConfig The default config for the instance
	 * @return {Axios} A new instance of Axios
	 */
	function createInstance(defaultConfig) {
	  var context = new Axios(defaultConfig);
	  var instance = bind(Axios.prototype.request, context);
	
	  // Copy axios.prototype to instance
	  utils.extend(instance, Axios.prototype, context);
	
	  // Copy context to instance
	  utils.extend(instance, context);
	
	  return instance;
	}
	
	// Create the default instance to be exported
	var axios = createInstance(defaults);
	
	// Expose Axios class to allow class inheritance
	axios.Axios = Axios;
	
	// Factory for creating new instances
	axios.create = function create(instanceConfig) {
	  return createInstance(utils.merge(defaults, instanceConfig));
	};
	
	// Expose Cancel & CancelToken
	axios.Cancel = __webpack_require__(26);
	axios.CancelToken = __webpack_require__(27);
	axios.isCancel = __webpack_require__(23);
	
	// Expose all/spread
	axios.all = function all(promises) {
	  return Promise.all(promises);
	};
	axios.spread = __webpack_require__(28);
	
	module.exports = axios;
	
	// Allow use of default import syntax in TypeScript
	module.exports.default = axios;


/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var bind = __webpack_require__(6);
	
	/*global toString:true*/
	
	// utils is a library of generic helper functions non-specific to axios
	
	var toString = Object.prototype.toString;
	
	/**
	 * Determine if a value is an Array
	 *
	 * @param {Object} val The value to test
	 * @returns {boolean} True if value is an Array, otherwise false
	 */
	function isArray(val) {
	  return toString.call(val) === '[object Array]';
	}
	
	/**
	 * Determine if a value is an ArrayBuffer
	 *
	 * @param {Object} val The value to test
	 * @returns {boolean} True if value is an ArrayBuffer, otherwise false
	 */
	function isArrayBuffer(val) {
	  return toString.call(val) === '[object ArrayBuffer]';
	}
	
	/**
	 * Determine if a value is a FormData
	 *
	 * @param {Object} val The value to test
	 * @returns {boolean} True if value is an FormData, otherwise false
	 */
	function isFormData(val) {
	  return (typeof FormData !== 'undefined') && (val instanceof FormData);
	}
	
	/**
	 * Determine if a value is a view on an ArrayBuffer
	 *
	 * @param {Object} val The value to test
	 * @returns {boolean} True if value is a view on an ArrayBuffer, otherwise false
	 */
	function isArrayBufferView(val) {
	  var result;
	  if ((typeof ArrayBuffer !== 'undefined') && (ArrayBuffer.isView)) {
	    result = ArrayBuffer.isView(val);
	  } else {
	    result = (val) && (val.buffer) && (val.buffer instanceof ArrayBuffer);
	  }
	  return result;
	}
	
	/**
	 * Determine if a value is a String
	 *
	 * @param {Object} val The value to test
	 * @returns {boolean} True if value is a String, otherwise false
	 */
	function isString(val) {
	  return typeof val === 'string';
	}
	
	/**
	 * Determine if a value is a Number
	 *
	 * @param {Object} val The value to test
	 * @returns {boolean} True if value is a Number, otherwise false
	 */
	function isNumber(val) {
	  return typeof val === 'number';
	}
	
	/**
	 * Determine if a value is undefined
	 *
	 * @param {Object} val The value to test
	 * @returns {boolean} True if the value is undefined, otherwise false
	 */
	function isUndefined(val) {
	  return typeof val === 'undefined';
	}
	
	/**
	 * Determine if a value is an Object
	 *
	 * @param {Object} val The value to test
	 * @returns {boolean} True if value is an Object, otherwise false
	 */
	function isObject(val) {
	  return val !== null && typeof val === 'object';
	}
	
	/**
	 * Determine if a value is a Date
	 *
	 * @param {Object} val The value to test
	 * @returns {boolean} True if value is a Date, otherwise false
	 */
	function isDate(val) {
	  return toString.call(val) === '[object Date]';
	}
	
	/**
	 * Determine if a value is a File
	 *
	 * @param {Object} val The value to test
	 * @returns {boolean} True if value is a File, otherwise false
	 */
	function isFile(val) {
	  return toString.call(val) === '[object File]';
	}
	
	/**
	 * Determine if a value is a Blob
	 *
	 * @param {Object} val The value to test
	 * @returns {boolean} True if value is a Blob, otherwise false
	 */
	function isBlob(val) {
	  return toString.call(val) === '[object Blob]';
	}
	
	/**
	 * Determine if a value is a Function
	 *
	 * @param {Object} val The value to test
	 * @returns {boolean} True if value is a Function, otherwise false
	 */
	function isFunction(val) {
	  return toString.call(val) === '[object Function]';
	}
	
	/**
	 * Determine if a value is a Stream
	 *
	 * @param {Object} val The value to test
	 * @returns {boolean} True if value is a Stream, otherwise false
	 */
	function isStream(val) {
	  return isObject(val) && isFunction(val.pipe);
	}
	
	/**
	 * Determine if a value is a URLSearchParams object
	 *
	 * @param {Object} val The value to test
	 * @returns {boolean} True if value is a URLSearchParams object, otherwise false
	 */
	function isURLSearchParams(val) {
	  return typeof URLSearchParams !== 'undefined' && val instanceof URLSearchParams;
	}
	
	/**
	 * Trim excess whitespace off the beginning and end of a string
	 *
	 * @param {String} str The String to trim
	 * @returns {String} The String freed of excess whitespace
	 */
	function trim(str) {
	  return str.replace(/^\s*/, '').replace(/\s*$/, '');
	}
	
	/**
	 * Determine if we're running in a standard browser environment
	 *
	 * This allows axios to run in a web worker, and react-native.
	 * Both environments support XMLHttpRequest, but not fully standard globals.
	 *
	 * web workers:
	 *  typeof window -> undefined
	 *  typeof document -> undefined
	 *
	 * react-native:
	 *  typeof document.createElement -> undefined
	 */
	function isStandardBrowserEnv() {
	  return (
	    typeof window !== 'undefined' &&
	    typeof document !== 'undefined' &&
	    typeof document.createElement === 'function'
	  );
	}
	
	/**
	 * Iterate over an Array or an Object invoking a function for each item.
	 *
	 * If `obj` is an Array callback will be called passing
	 * the value, index, and complete array for each item.
	 *
	 * If 'obj' is an Object callback will be called passing
	 * the value, key, and complete object for each property.
	 *
	 * @param {Object|Array} obj The object to iterate
	 * @param {Function} fn The callback to invoke for each item
	 */
	function forEach(obj, fn) {
	  // Don't bother if no value provided
	  if (obj === null || typeof obj === 'undefined') {
	    return;
	  }
	
	  // Force an array if not already something iterable
	  if (typeof obj !== 'object' && !isArray(obj)) {
	    /*eslint no-param-reassign:0*/
	    obj = [obj];
	  }
	
	  if (isArray(obj)) {
	    // Iterate over array values
	    for (var i = 0, l = obj.length; i < l; i++) {
	      fn.call(null, obj[i], i, obj);
	    }
	  } else {
	    // Iterate over object keys
	    for (var key in obj) {
	      if (Object.prototype.hasOwnProperty.call(obj, key)) {
	        fn.call(null, obj[key], key, obj);
	      }
	    }
	  }
	}
	
	/**
	 * Accepts varargs expecting each argument to be an object, then
	 * immutably merges the properties of each object and returns result.
	 *
	 * When multiple objects contain the same key the later object in
	 * the arguments list will take precedence.
	 *
	 * Example:
	 *
	 * ```js
	 * var result = merge({foo: 123}, {foo: 456});
	 * console.log(result.foo); // outputs 456
	 * ```
	 *
	 * @param {Object} obj1 Object to merge
	 * @returns {Object} Result of all merge properties
	 */
	function merge(/* obj1, obj2, obj3, ... */) {
	  var result = {};
	  function assignValue(val, key) {
	    if (typeof result[key] === 'object' && typeof val === 'object') {
	      result[key] = merge(result[key], val);
	    } else {
	      result[key] = val;
	    }
	  }
	
	  for (var i = 0, l = arguments.length; i < l; i++) {
	    forEach(arguments[i], assignValue);
	  }
	  return result;
	}
	
	/**
	 * Extends object a by mutably adding to it the properties of object b.
	 *
	 * @param {Object} a The object to be extended
	 * @param {Object} b The object to copy properties from
	 * @param {Object} thisArg The object to bind function to
	 * @return {Object} The resulting value of object a
	 */
	function extend(a, b, thisArg) {
	  forEach(b, function assignValue(val, key) {
	    if (thisArg && typeof val === 'function') {
	      a[key] = bind(val, thisArg);
	    } else {
	      a[key] = val;
	    }
	  });
	  return a;
	}
	
	module.exports = {
	  isArray: isArray,
	  isArrayBuffer: isArrayBuffer,
	  isFormData: isFormData,
	  isArrayBufferView: isArrayBufferView,
	  isString: isString,
	  isNumber: isNumber,
	  isObject: isObject,
	  isUndefined: isUndefined,
	  isDate: isDate,
	  isFile: isFile,
	  isBlob: isBlob,
	  isFunction: isFunction,
	  isStream: isStream,
	  isURLSearchParams: isURLSearchParams,
	  isStandardBrowserEnv: isStandardBrowserEnv,
	  forEach: forEach,
	  merge: merge,
	  extend: extend,
	  trim: trim
	};


/***/ },
/* 6 */
/***/ function(module, exports) {

	'use strict';
	
	module.exports = function bind(fn, thisArg) {
	  return function wrap() {
	    var args = new Array(arguments.length);
	    for (var i = 0; i < args.length; i++) {
	      args[i] = arguments[i];
	    }
	    return fn.apply(thisArg, args);
	  };
	};


/***/ },
/* 7 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var defaults = __webpack_require__(8);
	var utils = __webpack_require__(5);
	var InterceptorManager = __webpack_require__(20);
	var dispatchRequest = __webpack_require__(21);
	var isAbsoluteURL = __webpack_require__(24);
	var combineURLs = __webpack_require__(25);
	
	/**
	 * Create a new instance of Axios
	 *
	 * @param {Object} instanceConfig The default config for the instance
	 */
	function Axios(instanceConfig) {
	  this.defaults = instanceConfig;
	  this.interceptors = {
	    request: new InterceptorManager(),
	    response: new InterceptorManager()
	  };
	}
	
	/**
	 * Dispatch a request
	 *
	 * @param {Object} config The config specific for this request (merged with this.defaults)
	 */
	Axios.prototype.request = function request(config) {
	  /*eslint no-param-reassign:0*/
	  // Allow for axios('example/url'[, config]) a la fetch API
	  if (typeof config === 'string') {
	    config = utils.merge({
	      url: arguments[0]
	    }, arguments[1]);
	  }
	
	  config = utils.merge(defaults, this.defaults, { method: 'get' }, config);
	
	  // Support baseURL config
	  if (config.baseURL && !isAbsoluteURL(config.url)) {
	    config.url = combineURLs(config.baseURL, config.url);
	  }
	
	  // Hook up interceptors middleware
	  var chain = [dispatchRequest, undefined];
	  var promise = Promise.resolve(config);
	
	  this.interceptors.request.forEach(function unshiftRequestInterceptors(interceptor) {
	    chain.unshift(interceptor.fulfilled, interceptor.rejected);
	  });
	
	  this.interceptors.response.forEach(function pushResponseInterceptors(interceptor) {
	    chain.push(interceptor.fulfilled, interceptor.rejected);
	  });
	
	  while (chain.length) {
	    promise = promise.then(chain.shift(), chain.shift());
	  }
	
	  return promise;
	};
	
	// Provide aliases for supported request methods
	utils.forEach(['delete', 'get', 'head'], function forEachMethodNoData(method) {
	  /*eslint func-names:0*/
	  Axios.prototype[method] = function(url, config) {
	    return this.request(utils.merge(config || {}, {
	      method: method,
	      url: url
	    }));
	  };
	});
	
	utils.forEach(['post', 'put', 'patch'], function forEachMethodWithData(method) {
	  /*eslint func-names:0*/
	  Axios.prototype[method] = function(url, data, config) {
	    return this.request(utils.merge(config || {}, {
	      method: method,
	      url: url,
	      data: data
	    }));
	  };
	});
	
	module.exports = Axios;


/***/ },
/* 8 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {'use strict';
	
	var utils = __webpack_require__(5);
	var normalizeHeaderName = __webpack_require__(10);
	
	var PROTECTION_PREFIX = /^\)\]\}',?\n/;
	var DEFAULT_CONTENT_TYPE = {
	  'Content-Type': 'application/x-www-form-urlencoded'
	};
	
	function setContentTypeIfUnset(headers, value) {
	  if (!utils.isUndefined(headers) && utils.isUndefined(headers['Content-Type'])) {
	    headers['Content-Type'] = value;
	  }
	}
	
	function getDefaultAdapter() {
	  var adapter;
	  if (typeof XMLHttpRequest !== 'undefined') {
	    // For browsers use XHR adapter
	    adapter = __webpack_require__(11);
	  } else if (typeof process !== 'undefined') {
	    // For node use HTTP adapter
	    adapter = __webpack_require__(11);
	  }
	  return adapter;
	}
	
	var defaults = {
	  adapter: getDefaultAdapter(),
	
	  transformRequest: [function transformRequest(data, headers) {
	    normalizeHeaderName(headers, 'Content-Type');
	    if (utils.isFormData(data) ||
	      utils.isArrayBuffer(data) ||
	      utils.isStream(data) ||
	      utils.isFile(data) ||
	      utils.isBlob(data)
	    ) {
	      return data;
	    }
	    if (utils.isArrayBufferView(data)) {
	      return data.buffer;
	    }
	    if (utils.isURLSearchParams(data)) {
	      setContentTypeIfUnset(headers, 'application/x-www-form-urlencoded;charset=utf-8');
	      return data.toString();
	    }
	    if (utils.isObject(data)) {
	      setContentTypeIfUnset(headers, 'application/json;charset=utf-8');
	      return JSON.stringify(data);
	    }
	    return data;
	  }],
	
	  transformResponse: [function transformResponse(data) {
	    /*eslint no-param-reassign:0*/
	    if (typeof data === 'string') {
	      data = data.replace(PROTECTION_PREFIX, '');
	      try {
	        data = JSON.parse(data);
	      } catch (e) { /* Ignore */ }
	    }
	    return data;
	  }],
	
	  timeout: 0,
	
	  xsrfCookieName: 'XSRF-TOKEN',
	  xsrfHeaderName: 'X-XSRF-TOKEN',
	
	  maxContentLength: -1,
	
	  validateStatus: function validateStatus(status) {
	    return status >= 200 && status < 300;
	  }
	};
	
	defaults.headers = {
	  common: {
	    'Accept': 'application/json, text/plain, */*'
	  }
	};
	
	utils.forEach(['delete', 'get', 'head'], function forEachMehtodNoData(method) {
	  defaults.headers[method] = {};
	});
	
	utils.forEach(['post', 'put', 'patch'], function forEachMethodWithData(method) {
	  defaults.headers[method] = utils.merge(DEFAULT_CONTENT_TYPE);
	});
	
	module.exports = defaults;
	
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(9)))

/***/ },
/* 9 */
/***/ function(module, exports) {

	// shim for using process in browser
	var process = module.exports = {};
	
	// cached from whatever global is present so that test runners that stub it
	// don't break things.  But we need to wrap it in a try catch in case it is
	// wrapped in strict mode code which doesn't define any globals.  It's inside a
	// function because try/catches deoptimize in certain engines.
	
	var cachedSetTimeout;
	var cachedClearTimeout;
	
	function defaultSetTimout() {
	    throw new Error('setTimeout has not been defined');
	}
	function defaultClearTimeout () {
	    throw new Error('clearTimeout has not been defined');
	}
	(function () {
	    try {
	        if (typeof setTimeout === 'function') {
	            cachedSetTimeout = setTimeout;
	        } else {
	            cachedSetTimeout = defaultSetTimout;
	        }
	    } catch (e) {
	        cachedSetTimeout = defaultSetTimout;
	    }
	    try {
	        if (typeof clearTimeout === 'function') {
	            cachedClearTimeout = clearTimeout;
	        } else {
	            cachedClearTimeout = defaultClearTimeout;
	        }
	    } catch (e) {
	        cachedClearTimeout = defaultClearTimeout;
	    }
	} ())
	function runTimeout(fun) {
	    if (cachedSetTimeout === setTimeout) {
	        //normal enviroments in sane situations
	        return setTimeout(fun, 0);
	    }
	    // if setTimeout wasn't available but was latter defined
	    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
	        cachedSetTimeout = setTimeout;
	        return setTimeout(fun, 0);
	    }
	    try {
	        // when when somebody has screwed with setTimeout but no I.E. maddness
	        return cachedSetTimeout(fun, 0);
	    } catch(e){
	        try {
	            // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
	            return cachedSetTimeout.call(null, fun, 0);
	        } catch(e){
	            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
	            return cachedSetTimeout.call(this, fun, 0);
	        }
	    }
	
	
	}
	function runClearTimeout(marker) {
	    if (cachedClearTimeout === clearTimeout) {
	        //normal enviroments in sane situations
	        return clearTimeout(marker);
	    }
	    // if clearTimeout wasn't available but was latter defined
	    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
	        cachedClearTimeout = clearTimeout;
	        return clearTimeout(marker);
	    }
	    try {
	        // when when somebody has screwed with setTimeout but no I.E. maddness
	        return cachedClearTimeout(marker);
	    } catch (e){
	        try {
	            // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
	            return cachedClearTimeout.call(null, marker);
	        } catch (e){
	            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
	            // Some versions of I.E. have different rules for clearTimeout vs setTimeout
	            return cachedClearTimeout.call(this, marker);
	        }
	    }
	
	
	
	}
	var queue = [];
	var draining = false;
	var currentQueue;
	var queueIndex = -1;
	
	function cleanUpNextTick() {
	    if (!draining || !currentQueue) {
	        return;
	    }
	    draining = false;
	    if (currentQueue.length) {
	        queue = currentQueue.concat(queue);
	    } else {
	        queueIndex = -1;
	    }
	    if (queue.length) {
	        drainQueue();
	    }
	}
	
	function drainQueue() {
	    if (draining) {
	        return;
	    }
	    var timeout = runTimeout(cleanUpNextTick);
	    draining = true;
	
	    var len = queue.length;
	    while(len) {
	        currentQueue = queue;
	        queue = [];
	        while (++queueIndex < len) {
	            if (currentQueue) {
	                currentQueue[queueIndex].run();
	            }
	        }
	        queueIndex = -1;
	        len = queue.length;
	    }
	    currentQueue = null;
	    draining = false;
	    runClearTimeout(timeout);
	}
	
	process.nextTick = function (fun) {
	    var args = new Array(arguments.length - 1);
	    if (arguments.length > 1) {
	        for (var i = 1; i < arguments.length; i++) {
	            args[i - 1] = arguments[i];
	        }
	    }
	    queue.push(new Item(fun, args));
	    if (queue.length === 1 && !draining) {
	        runTimeout(drainQueue);
	    }
	};
	
	// v8 likes predictible objects
	function Item(fun, array) {
	    this.fun = fun;
	    this.array = array;
	}
	Item.prototype.run = function () {
	    this.fun.apply(null, this.array);
	};
	process.title = 'browser';
	process.browser = true;
	process.env = {};
	process.argv = [];
	process.version = ''; // empty string to avoid regexp issues
	process.versions = {};
	
	function noop() {}
	
	process.on = noop;
	process.addListener = noop;
	process.once = noop;
	process.off = noop;
	process.removeListener = noop;
	process.removeAllListeners = noop;
	process.emit = noop;
	
	process.binding = function (name) {
	    throw new Error('process.binding is not supported');
	};
	
	process.cwd = function () { return '/' };
	process.chdir = function (dir) {
	    throw new Error('process.chdir is not supported');
	};
	process.umask = function() { return 0; };


/***/ },
/* 10 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var utils = __webpack_require__(5);
	
	module.exports = function normalizeHeaderName(headers, normalizedName) {
	  utils.forEach(headers, function processHeader(value, name) {
	    if (name !== normalizedName && name.toUpperCase() === normalizedName.toUpperCase()) {
	      headers[normalizedName] = value;
	      delete headers[name];
	    }
	  });
	};


/***/ },
/* 11 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {'use strict';
	
	var utils = __webpack_require__(5);
	var settle = __webpack_require__(12);
	var buildURL = __webpack_require__(15);
	var parseHeaders = __webpack_require__(16);
	var isURLSameOrigin = __webpack_require__(17);
	var createError = __webpack_require__(13);
	var btoa = (typeof window !== 'undefined' && window.btoa && window.btoa.bind(window)) || __webpack_require__(18);
	
	module.exports = function xhrAdapter(config) {
	  return new Promise(function dispatchXhrRequest(resolve, reject) {
	    var requestData = config.data;
	    var requestHeaders = config.headers;
	
	    if (utils.isFormData(requestData)) {
	      delete requestHeaders['Content-Type']; // Let the browser set it
	    }
	
	    var request = new XMLHttpRequest();
	    var loadEvent = 'onreadystatechange';
	    var xDomain = false;
	
	    // For IE 8/9 CORS support
	    // Only supports POST and GET calls and doesn't returns the response headers.
	    // DON'T do this for testing b/c XMLHttpRequest is mocked, not XDomainRequest.
	    if (process.env.NODE_ENV !== 'test' &&
	        typeof window !== 'undefined' &&
	        window.XDomainRequest && !('withCredentials' in request) &&
	        !isURLSameOrigin(config.url)) {
	      request = new window.XDomainRequest();
	      loadEvent = 'onload';
	      xDomain = true;
	      request.onprogress = function handleProgress() {};
	      request.ontimeout = function handleTimeout() {};
	    }
	
	    // HTTP basic authentication
	    if (config.auth) {
	      var username = config.auth.username || '';
	      var password = config.auth.password || '';
	      requestHeaders.Authorization = 'Basic ' + btoa(username + ':' + password);
	    }
	
	    request.open(config.method.toUpperCase(), buildURL(config.url, config.params, config.paramsSerializer), true);
	
	    // Set the request timeout in MS
	    request.timeout = config.timeout;
	
	    // Listen for ready state
	    request[loadEvent] = function handleLoad() {
	      if (!request || (request.readyState !== 4 && !xDomain)) {
	        return;
	      }
	
	      // The request errored out and we didn't get a response, this will be
	      // handled by onerror instead
	      // With one exception: request that using file: protocol, most browsers
	      // will return status as 0 even though it's a successful request
	      if (request.status === 0 && !(request.responseURL && request.responseURL.indexOf('file:') === 0)) {
	        return;
	      }
	
	      // Prepare the response
	      var responseHeaders = 'getAllResponseHeaders' in request ? parseHeaders(request.getAllResponseHeaders()) : null;
	      var responseData = !config.responseType || config.responseType === 'text' ? request.responseText : request.response;
	      var response = {
	        data: responseData,
	        // IE sends 1223 instead of 204 (https://github.com/mzabriskie/axios/issues/201)
	        status: request.status === 1223 ? 204 : request.status,
	        statusText: request.status === 1223 ? 'No Content' : request.statusText,
	        headers: responseHeaders,
	        config: config,
	        request: request
	      };
	
	      settle(resolve, reject, response);
	
	      // Clean up request
	      request = null;
	    };
	
	    // Handle low level network errors
	    request.onerror = function handleError() {
	      // Real errors are hidden from us by the browser
	      // onerror should only fire if it's a network error
	      reject(createError('Network Error', config));
	
	      // Clean up request
	      request = null;
	    };
	
	    // Handle timeout
	    request.ontimeout = function handleTimeout() {
	      reject(createError('timeout of ' + config.timeout + 'ms exceeded', config, 'ECONNABORTED'));
	
	      // Clean up request
	      request = null;
	    };
	
	    // Add xsrf header
	    // This is only done if running in a standard browser environment.
	    // Specifically not if we're in a web worker, or react-native.
	    if (utils.isStandardBrowserEnv()) {
	      var cookies = __webpack_require__(19);
	
	      // Add xsrf header
	      var xsrfValue = (config.withCredentials || isURLSameOrigin(config.url)) && config.xsrfCookieName ?
	          cookies.read(config.xsrfCookieName) :
	          undefined;
	
	      if (xsrfValue) {
	        requestHeaders[config.xsrfHeaderName] = xsrfValue;
	      }
	    }
	
	    // Add headers to the request
	    if ('setRequestHeader' in request) {
	      utils.forEach(requestHeaders, function setRequestHeader(val, key) {
	        if (typeof requestData === 'undefined' && key.toLowerCase() === 'content-type') {
	          // Remove Content-Type if data is undefined
	          delete requestHeaders[key];
	        } else {
	          // Otherwise add header to the request
	          request.setRequestHeader(key, val);
	        }
	      });
	    }
	
	    // Add withCredentials to request if needed
	    if (config.withCredentials) {
	      request.withCredentials = true;
	    }
	
	    // Add responseType to request if needed
	    if (config.responseType) {
	      try {
	        request.responseType = config.responseType;
	      } catch (e) {
	        if (request.responseType !== 'json') {
	          throw e;
	        }
	      }
	    }
	
	    // Handle progress if needed
	    if (typeof config.onDownloadProgress === 'function') {
	      request.addEventListener('progress', config.onDownloadProgress);
	    }
	
	    // Not all browsers support upload events
	    if (typeof config.onUploadProgress === 'function' && request.upload) {
	      request.upload.addEventListener('progress', config.onUploadProgress);
	    }
	
	    if (config.cancelToken) {
	      // Handle cancellation
	      config.cancelToken.promise.then(function onCanceled(cancel) {
	        if (!request) {
	          return;
	        }
	
	        request.abort();
	        reject(cancel);
	        // Clean up request
	        request = null;
	      });
	    }
	
	    if (requestData === undefined) {
	      requestData = null;
	    }
	
	    // Send the request
	    request.send(requestData);
	  });
	};
	
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(9)))

/***/ },
/* 12 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var createError = __webpack_require__(13);
	
	/**
	 * Resolve or reject a Promise based on response status.
	 *
	 * @param {Function} resolve A function that resolves the promise.
	 * @param {Function} reject A function that rejects the promise.
	 * @param {object} response The response.
	 */
	module.exports = function settle(resolve, reject, response) {
	  var validateStatus = response.config.validateStatus;
	  // Note: status is not exposed by XDomainRequest
	  if (!response.status || !validateStatus || validateStatus(response.status)) {
	    resolve(response);
	  } else {
	    reject(createError(
	      'Request failed with status code ' + response.status,
	      response.config,
	      null,
	      response
	    ));
	  }
	};


/***/ },
/* 13 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var enhanceError = __webpack_require__(14);
	
	/**
	 * Create an Error with the specified message, config, error code, and response.
	 *
	 * @param {string} message The error message.
	 * @param {Object} config The config.
	 * @param {string} [code] The error code (for example, 'ECONNABORTED').
	 @ @param {Object} [response] The response.
	 * @returns {Error} The created error.
	 */
	module.exports = function createError(message, config, code, response) {
	  var error = new Error(message);
	  return enhanceError(error, config, code, response);
	};


/***/ },
/* 14 */
/***/ function(module, exports) {

	'use strict';
	
	/**
	 * Update an Error with the specified config, error code, and response.
	 *
	 * @param {Error} error The error to update.
	 * @param {Object} config The config.
	 * @param {string} [code] The error code (for example, 'ECONNABORTED').
	 @ @param {Object} [response] The response.
	 * @returns {Error} The error.
	 */
	module.exports = function enhanceError(error, config, code, response) {
	  error.config = config;
	  if (code) {
	    error.code = code;
	  }
	  error.response = response;
	  return error;
	};


/***/ },
/* 15 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var utils = __webpack_require__(5);
	
	function encode(val) {
	  return encodeURIComponent(val).
	    replace(/%40/gi, '@').
	    replace(/%3A/gi, ':').
	    replace(/%24/g, '$').
	    replace(/%2C/gi, ',').
	    replace(/%20/g, '+').
	    replace(/%5B/gi, '[').
	    replace(/%5D/gi, ']');
	}
	
	/**
	 * Build a URL by appending params to the end
	 *
	 * @param {string} url The base of the url (e.g., http://www.google.com)
	 * @param {object} [params] The params to be appended
	 * @returns {string} The formatted url
	 */
	module.exports = function buildURL(url, params, paramsSerializer) {
	  /*eslint no-param-reassign:0*/
	  if (!params) {
	    return url;
	  }
	
	  var serializedParams;
	  if (paramsSerializer) {
	    serializedParams = paramsSerializer(params);
	  } else if (utils.isURLSearchParams(params)) {
	    serializedParams = params.toString();
	  } else {
	    var parts = [];
	
	    utils.forEach(params, function serialize(val, key) {
	      if (val === null || typeof val === 'undefined') {
	        return;
	      }
	
	      if (utils.isArray(val)) {
	        key = key + '[]';
	      }
	
	      if (!utils.isArray(val)) {
	        val = [val];
	      }
	
	      utils.forEach(val, function parseValue(v) {
	        if (utils.isDate(v)) {
	          v = v.toISOString();
	        } else if (utils.isObject(v)) {
	          v = JSON.stringify(v);
	        }
	        parts.push(encode(key) + '=' + encode(v));
	      });
	    });
	
	    serializedParams = parts.join('&');
	  }
	
	  if (serializedParams) {
	    url += (url.indexOf('?') === -1 ? '?' : '&') + serializedParams;
	  }
	
	  return url;
	};


/***/ },
/* 16 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var utils = __webpack_require__(5);
	
	/**
	 * Parse headers into an object
	 *
	 * ```
	 * Date: Wed, 27 Aug 2014 08:58:49 GMT
	 * Content-Type: application/json
	 * Connection: keep-alive
	 * Transfer-Encoding: chunked
	 * ```
	 *
	 * @param {String} headers Headers needing to be parsed
	 * @returns {Object} Headers parsed into an object
	 */
	module.exports = function parseHeaders(headers) {
	  var parsed = {};
	  var key;
	  var val;
	  var i;
	
	  if (!headers) { return parsed; }
	
	  utils.forEach(headers.split('\n'), function parser(line) {
	    i = line.indexOf(':');
	    key = utils.trim(line.substr(0, i)).toLowerCase();
	    val = utils.trim(line.substr(i + 1));
	
	    if (key) {
	      parsed[key] = parsed[key] ? parsed[key] + ', ' + val : val;
	    }
	  });
	
	  return parsed;
	};


/***/ },
/* 17 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var utils = __webpack_require__(5);
	
	module.exports = (
	  utils.isStandardBrowserEnv() ?
	
	  // Standard browser envs have full support of the APIs needed to test
	  // whether the request URL is of the same origin as current location.
	  (function standardBrowserEnv() {
	    var msie = /(msie|trident)/i.test(navigator.userAgent);
	    var urlParsingNode = document.createElement('a');
	    var originURL;
	
	    /**
	    * Parse a URL to discover it's components
	    *
	    * @param {String} url The URL to be parsed
	    * @returns {Object}
	    */
	    function resolveURL(url) {
	      var href = url;
	
	      if (msie) {
	        // IE needs attribute set twice to normalize properties
	        urlParsingNode.setAttribute('href', href);
	        href = urlParsingNode.href;
	      }
	
	      urlParsingNode.setAttribute('href', href);
	
	      // urlParsingNode provides the UrlUtils interface - http://url.spec.whatwg.org/#urlutils
	      return {
	        href: urlParsingNode.href,
	        protocol: urlParsingNode.protocol ? urlParsingNode.protocol.replace(/:$/, '') : '',
	        host: urlParsingNode.host,
	        search: urlParsingNode.search ? urlParsingNode.search.replace(/^\?/, '') : '',
	        hash: urlParsingNode.hash ? urlParsingNode.hash.replace(/^#/, '') : '',
	        hostname: urlParsingNode.hostname,
	        port: urlParsingNode.port,
	        pathname: (urlParsingNode.pathname.charAt(0) === '/') ?
	                  urlParsingNode.pathname :
	                  '/' + urlParsingNode.pathname
	      };
	    }
	
	    originURL = resolveURL(window.location.href);
	
	    /**
	    * Determine if a URL shares the same origin as the current location
	    *
	    * @param {String} requestURL The URL to test
	    * @returns {boolean} True if URL shares the same origin, otherwise false
	    */
	    return function isURLSameOrigin(requestURL) {
	      var parsed = (utils.isString(requestURL)) ? resolveURL(requestURL) : requestURL;
	      return (parsed.protocol === originURL.protocol &&
	            parsed.host === originURL.host);
	    };
	  })() :
	
	  // Non standard browser envs (web workers, react-native) lack needed support.
	  (function nonStandardBrowserEnv() {
	    return function isURLSameOrigin() {
	      return true;
	    };
	  })()
	);


/***/ },
/* 18 */
/***/ function(module, exports) {

	'use strict';
	
	// btoa polyfill for IE<10 courtesy https://github.com/davidchambers/Base64.js
	
	var chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';
	
	function E() {
	  this.message = 'String contains an invalid character';
	}
	E.prototype = new Error;
	E.prototype.code = 5;
	E.prototype.name = 'InvalidCharacterError';
	
	function btoa(input) {
	  var str = String(input);
	  var output = '';
	  for (
	    // initialize result and counter
	    var block, charCode, idx = 0, map = chars;
	    // if the next str index does not exist:
	    //   change the mapping table to "="
	    //   check if d has no fractional digits
	    str.charAt(idx | 0) || (map = '=', idx % 1);
	    // "8 - idx % 1 * 8" generates the sequence 2, 4, 6, 8
	    output += map.charAt(63 & block >> 8 - idx % 1 * 8)
	  ) {
	    charCode = str.charCodeAt(idx += 3 / 4);
	    if (charCode > 0xFF) {
	      throw new E();
	    }
	    block = block << 8 | charCode;
	  }
	  return output;
	}
	
	module.exports = btoa;


/***/ },
/* 19 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var utils = __webpack_require__(5);
	
	module.exports = (
	  utils.isStandardBrowserEnv() ?
	
	  // Standard browser envs support document.cookie
	  (function standardBrowserEnv() {
	    return {
	      write: function write(name, value, expires, path, domain, secure) {
	        var cookie = [];
	        cookie.push(name + '=' + encodeURIComponent(value));
	
	        if (utils.isNumber(expires)) {
	          cookie.push('expires=' + new Date(expires).toGMTString());
	        }
	
	        if (utils.isString(path)) {
	          cookie.push('path=' + path);
	        }
	
	        if (utils.isString(domain)) {
	          cookie.push('domain=' + domain);
	        }
	
	        if (secure === true) {
	          cookie.push('secure');
	        }
	
	        document.cookie = cookie.join('; ');
	      },
	
	      read: function read(name) {
	        var match = document.cookie.match(new RegExp('(^|;\\s*)(' + name + ')=([^;]*)'));
	        return (match ? decodeURIComponent(match[3]) : null);
	      },
	
	      remove: function remove(name) {
	        this.write(name, '', Date.now() - 86400000);
	      }
	    };
	  })() :
	
	  // Non standard browser env (web workers, react-native) lack needed support.
	  (function nonStandardBrowserEnv() {
	    return {
	      write: function write() {},
	      read: function read() { return null; },
	      remove: function remove() {}
	    };
	  })()
	);


/***/ },
/* 20 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var utils = __webpack_require__(5);
	
	function InterceptorManager() {
	  this.handlers = [];
	}
	
	/**
	 * Add a new interceptor to the stack
	 *
	 * @param {Function} fulfilled The function to handle `then` for a `Promise`
	 * @param {Function} rejected The function to handle `reject` for a `Promise`
	 *
	 * @return {Number} An ID used to remove interceptor later
	 */
	InterceptorManager.prototype.use = function use(fulfilled, rejected) {
	  this.handlers.push({
	    fulfilled: fulfilled,
	    rejected: rejected
	  });
	  return this.handlers.length - 1;
	};
	
	/**
	 * Remove an interceptor from the stack
	 *
	 * @param {Number} id The ID that was returned by `use`
	 */
	InterceptorManager.prototype.eject = function eject(id) {
	  if (this.handlers[id]) {
	    this.handlers[id] = null;
	  }
	};
	
	/**
	 * Iterate over all the registered interceptors
	 *
	 * This method is particularly useful for skipping over any
	 * interceptors that may have become `null` calling `eject`.
	 *
	 * @param {Function} fn The function to call for each interceptor
	 */
	InterceptorManager.prototype.forEach = function forEach(fn) {
	  utils.forEach(this.handlers, function forEachHandler(h) {
	    if (h !== null) {
	      fn(h);
	    }
	  });
	};
	
	module.exports = InterceptorManager;


/***/ },
/* 21 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var utils = __webpack_require__(5);
	var transformData = __webpack_require__(22);
	var isCancel = __webpack_require__(23);
	var defaults = __webpack_require__(8);
	
	/**
	 * Throws a `Cancel` if cancellation has been requested.
	 */
	function throwIfCancellationRequested(config) {
	  if (config.cancelToken) {
	    config.cancelToken.throwIfRequested();
	  }
	}
	
	/**
	 * Dispatch a request to the server using the configured adapter.
	 *
	 * @param {object} config The config that is to be used for the request
	 * @returns {Promise} The Promise to be fulfilled
	 */
	module.exports = function dispatchRequest(config) {
	  throwIfCancellationRequested(config);
	
	  // Ensure headers exist
	  config.headers = config.headers || {};
	
	  // Transform request data
	  config.data = transformData(
	    config.data,
	    config.headers,
	    config.transformRequest
	  );
	
	  // Flatten headers
	  config.headers = utils.merge(
	    config.headers.common || {},
	    config.headers[config.method] || {},
	    config.headers || {}
	  );
	
	  utils.forEach(
	    ['delete', 'get', 'head', 'post', 'put', 'patch', 'common'],
	    function cleanHeaderConfig(method) {
	      delete config.headers[method];
	    }
	  );
	
	  var adapter = config.adapter || defaults.adapter;
	
	  return adapter(config).then(function onAdapterResolution(response) {
	    throwIfCancellationRequested(config);
	
	    // Transform response data
	    response.data = transformData(
	      response.data,
	      response.headers,
	      config.transformResponse
	    );
	
	    return response;
	  }, function onAdapterRejection(reason) {
	    if (!isCancel(reason)) {
	      throwIfCancellationRequested(config);
	
	      // Transform response data
	      if (reason && reason.response) {
	        reason.response.data = transformData(
	          reason.response.data,
	          reason.response.headers,
	          config.transformResponse
	        );
	      }
	    }
	
	    return Promise.reject(reason);
	  });
	};


/***/ },
/* 22 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var utils = __webpack_require__(5);
	
	/**
	 * Transform the data for a request or a response
	 *
	 * @param {Object|String} data The data to be transformed
	 * @param {Array} headers The headers for the request or response
	 * @param {Array|Function} fns A single function or Array of functions
	 * @returns {*} The resulting transformed data
	 */
	module.exports = function transformData(data, headers, fns) {
	  /*eslint no-param-reassign:0*/
	  utils.forEach(fns, function transform(fn) {
	    data = fn(data, headers);
	  });
	
	  return data;
	};


/***/ },
/* 23 */
/***/ function(module, exports) {

	'use strict';
	
	module.exports = function isCancel(value) {
	  return !!(value && value.__CANCEL__);
	};


/***/ },
/* 24 */
/***/ function(module, exports) {

	'use strict';
	
	/**
	 * Determines whether the specified URL is absolute
	 *
	 * @param {string} url The URL to test
	 * @returns {boolean} True if the specified URL is absolute, otherwise false
	 */
	module.exports = function isAbsoluteURL(url) {
	  // A URL is considered absolute if it begins with "<scheme>://" or "//" (protocol-relative URL).
	  // RFC 3986 defines scheme name as a sequence of characters beginning with a letter and followed
	  // by any combination of letters, digits, plus, period, or hyphen.
	  return /^([a-z][a-z\d\+\-\.]*:)?\/\//i.test(url);
	};


/***/ },
/* 25 */
/***/ function(module, exports) {

	'use strict';
	
	/**
	 * Creates a new URL by combining the specified URLs
	 *
	 * @param {string} baseURL The base URL
	 * @param {string} relativeURL The relative URL
	 * @returns {string} The combined URL
	 */
	module.exports = function combineURLs(baseURL, relativeURL) {
	  return baseURL.replace(/\/+$/, '') + '/' + relativeURL.replace(/^\/+/, '');
	};


/***/ },
/* 26 */
/***/ function(module, exports) {

	'use strict';
	
	/**
	 * A `Cancel` is an object that is thrown when an operation is canceled.
	 *
	 * @class
	 * @param {string=} message The message.
	 */
	function Cancel(message) {
	  this.message = message;
	}
	
	Cancel.prototype.toString = function toString() {
	  return 'Cancel' + (this.message ? ': ' + this.message : '');
	};
	
	Cancel.prototype.__CANCEL__ = true;
	
	module.exports = Cancel;


/***/ },
/* 27 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var Cancel = __webpack_require__(26);
	
	/**
	 * A `CancelToken` is an object that can be used to request cancellation of an operation.
	 *
	 * @class
	 * @param {Function} executor The executor function.
	 */
	function CancelToken(executor) {
	  if (typeof executor !== 'function') {
	    throw new TypeError('executor must be a function.');
	  }
	
	  var resolvePromise;
	  this.promise = new Promise(function promiseExecutor(resolve) {
	    resolvePromise = resolve;
	  });
	
	  var token = this;
	  executor(function cancel(message) {
	    if (token.reason) {
	      // Cancellation has already been requested
	      return;
	    }
	
	    token.reason = new Cancel(message);
	    resolvePromise(token.reason);
	  });
	}
	
	/**
	 * Throws a `Cancel` if cancellation has been requested.
	 */
	CancelToken.prototype.throwIfRequested = function throwIfRequested() {
	  if (this.reason) {
	    throw this.reason;
	  }
	};
	
	/**
	 * Returns an object that contains a new `CancelToken` and a function that, when called,
	 * cancels the `CancelToken`.
	 */
	CancelToken.source = function source() {
	  var cancel;
	  var token = new CancelToken(function executor(c) {
	    cancel = c;
	  });
	  return {
	    token: token,
	    cancel: cancel
	  };
	};
	
	module.exports = CancelToken;


/***/ },
/* 28 */
/***/ function(module, exports) {

	'use strict';
	
	/**
	 * Syntactic sugar for invoking a function and expanding an array for arguments.
	 *
	 * Common use case would be to use `Function.prototype.apply`.
	 *
	 *  ```js
	 *  function f(x, y, z) {}
	 *  var args = [1, 2, 3];
	 *  f.apply(null, args);
	 *  ```
	 *
	 * With `spread` this example can be re-written.
	 *
	 *  ```js
	 *  spread(function(x, y, z) {})([1, 2, 3]);
	 *  ```
	 *
	 * @param {Function} callback
	 * @returns {Function}
	 */
	module.exports = function spread(callback) {
	  return function wrap(arr) {
	    return callback.apply(null, arr);
	  };
	};


/***/ },
/* 29 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var Store_1 = __webpack_require__(30);
	/**
	 * A Model is usually relative to a table in the database.
	 */
	var Model = (function () {
	    function Model() {
	    }
	    /**
	     * Get model store
	     */
	    Model.prototype.store = function () {
	        var self = this.constructor;
	        return self.resolveStore();
	    };
	    /**
	     * Get an instance of store
	     */
	    Model.resolveStore = function (properties) {
	        if (properties === void 0) { properties = undefined; }
	        return this.store = this.store || this.createStore(properties);
	    };
	    /**
	     * Create new instance of store
	     */
	    Model.createStore = function (properties) {
	        if (properties === void 0) { properties = this.storeProperties; }
	        return new Store_1.default(this, properties);
	    };
	    /**
	     * Get value of primary key
	     */
	    Model.prototype.key = function () {
	        var self = this.constructor;
	        return this[self.keyColumn];
	    };
	    /**
	     * Get mapped properties with values of model
	     * The shallow map does not contain objects (consequently, does not contain FKs)
	     */
	    Model.prototype.map = function (denormalize) {
	        var _this = this;
	        if (denormalize === void 0) { denormalize = true; }
	        var self = this.constructor;
	        var map = {};
	        Object.keys(this).forEach(function (key) {
	            var value = _this[key];
	            if (denormalize) {
	                value = self.denormalize(key, value);
	            }
	            if (typeof value !== 'object') {
	                map[key] = value;
	            }
	        });
	        return map;
	    };
	    /**
	     * Get foreign key value for a given model
	     */
	    Model.prototype.foreignKey = function (model) {
	        return this[model.foreignKey()];
	    };
	    /**
	     * Get foreign key name for a given model
	     */
	    Model.foreignKey = function () {
	        return this.singularized() + "_" + this.keyColumn;
	    };
	    /**
	     * Camelize transformer name
	     */
	    Model.camelizeTransformer = function (value) {
	        return value.split(new RegExp('[_|-]')).map(function (part) {
	            return part.substring(0, 1).toUpperCase() + part.substring(1);
	        }).join('');
	    };
	    /**
	     * Resolve normalizing function
	     */
	    Model.resolveTransformer = function (key, type) {
	        if (type === void 0) { type = 'normalize'; }
	        var underscored = type + "_" + key;
	        if (this[underscored]) {
	            return underscored;
	        }
	        var camel = type + this.camelizeTransformer(key);
	        if (this[camel]) {
	            return camel;
	        }
	    };
	    /**
	     * Normalize property
	     */
	    Model.normalize = function (key, value) {
	        var method = this.resolveTransformer(key);
	        return method ? this[method](value) : value;
	    };
	    /**
	     * Denormalize property
	     */
	    Model.denormalize = function (key, value) {
	        var method = this.resolveTransformer(key, 'denormalize');
	        return method ? this[method](value) : value;
	    };
	    /**
	     * Set values to instance
	     */
	    Model.prototype.set = function (values, normalize) {
	        var _this = this;
	        if (normalize === void 0) { normalize = false; }
	        var self = this.constructor;
	        Object.keys(values).forEach(function (key) {
	            var value = values[key];
	            _this[key] = normalize ? self.normalize(key, value) : value;
	        });
	        return this;
	    };
	    /**
	     * Duplicate model
	     */
	    Model.prototype.duplicate = function () {
	        var self = this.constructor;
	        var map = this.map(false);
	        delete map[self.keyColumn];
	        return self.make(map);
	    };
	    /**
	     * Create one or an array of model instances
	     */
	    Model.make = function (values, normalize) {
	        var _this = this;
	        if (normalize === void 0) { normalize = false; }
	        if (Array.isArray(values)) {
	            return values.map(function (it) { return _this.make(it); });
	        }
	        return new this().set(values, normalize);
	    };
	    /**
	     * Reload model instance
	     */
	    Model.prototype.reload = function () {
	        var self = this.constructor;
	        return self.find(this.key());
	    };
	    /**
	     * Find model object by id
	     */
	    Model.find = function (key, options) {
	        if (options === void 0) { options = undefined; }
	        return this.resolveStore().get(key, options);
	    };
	    /**
	     * Persist model
	     */
	    Model.prototype.save = function (options) {
	        if (options === void 0) { options = undefined; }
	        var self = this.constructor;
	        return self.save(this.map(), options);
	    };
	    /**
	     * Create and persist one or more instances
	     */
	    Model.save = function (values, options) {
	        var _this = this;
	        if (options === void 0) { options = undefined; }
	        if (Array.isArray(values)) {
	            return values.map(function (it) { return _this.save(it); });
	        }
	        if (values[this.keyColumn]) {
	            return this.resolveStore().update(values, options);
	        }
	        return this.resolveStore().create(values, options);
	    };
	    /**
	     * Destroy model
	     */
	    Model.prototype.destroy = function (options) {
	        if (options === void 0) { options = undefined; }
	        var self = this.constructor;
	        return self.destroy(this.key(), options);
	    };
	    /**
	     * Destroy
	     */
	    Model.destroy = function (key, options) {
	        var _this = this;
	        if (options === void 0) { options = undefined; }
	        if (Array.isArray(key)) {
	            return key.map(function (it) { return _this.destroy(it); });
	        }
	        return this.resolveStore().destroy(key, options);
	    };
	    /**
	     * Get promise to belongsTo FK relation
	     */
	    Model.prototype.belongsTo = function (model, options) {
	        if (options === void 0) { options = undefined; }
	        return model.find(this.foreignKey(model), options);
	    };
	    /**
	     * Get promise to belongsToMany FK relation
	     */
	    Model.prototype.belongsToMany = function (model, options) {
	        if (options === void 0) { options = undefined; }
	        var self = this.constructor;
	        return self.belongsToMany(model, this.key(), options);
	    };
	    /**
	     * Get promise to belongsToMany FK relation
	     */
	    Model.belongsToMany = function (model, value, options) {
	        if (options === void 0) { options = undefined; }
	        return this.hasMany(model, value, options);
	    };
	    /**
	     * Get promise to hasOne FK relation
	     */
	    Model.prototype.hasOne = function (model, options) {
	        if (options === void 0) { options = undefined; }
	        var self = this.constructor;
	        return self.hasOne(model, this.key(), options);
	    };
	    /**
	     * Resolve first promise result or null
	     */
	    Model.resolveFirst = function (promise) {
	        return new Promise(function (resolve, reject) {
	            promise.then(function (objects) {
	                resolve(objects.length ? objects[0] : null);
	            }, reject);
	        });
	    };
	    /**
	     * Get promise to hasOne FK relation statically
	     */
	    Model.hasOne = function (model, key, options) {
	        if (options === void 0) { options = undefined; }
	        var promise = this.hasMany(model, key, options);
	        return this.resolveFirst(promise);
	    };
	    /**
	     * Get promise to hasMany FK relation
	     */
	    Model.prototype.hasMany = function (model, options) {
	        if (options === void 0) { options = undefined; }
	        var self = this.constructor;
	        return self.hasMany(model, this.key(), options);
	    };
	    /**
	     * Get promise to hasMany FK relation statically
	     */
	    Model.hasMany = function (model, key, options) {
	        if (options === void 0) { options = undefined; }
	        return this.resolveStore().foreign(model, key, options);
	    };
	    /**
	     * Call action for model
	     */
	    Model.prototype.act = function (action, options) {
	        if (options === void 0) { options = undefined; }
	        var self = this.constructor;
	        return self.act(this.key(), action, options);
	    };
	    /**
	     * Call action
	     */
	    Model.act = function (key, action, options) {
	        if (options === void 0) { options = undefined; }
	        return this.resolveStore().act(key, action, options);
	    };
	    /**
	     * Find model object by property value
	     */
	    Model.where = function (property, key, options) {
	        if (options === void 0) { options = undefined; }
	        return this.resolveStore().where(property, key, options);
	    };
	    /**
	     * Get list of stores
	     */
	    Model.all = function (options) {
	        if (options === void 0) { options = undefined; }
	        return this.resolveStore().index(options);
	    };
	    /**
	     * Get singularized path
	     * If the `singular` variable is not defined, guess it from the `path`
	     */
	    Model.singularized = function () {
	        return this.singular || this.path.substring(0, this.path.length - 1);
	    };
	    return Model;
	}());
	/**
	 * The name of the primary key column
	 */
	Model.keyColumn = 'id';
	/**
	 * This variable is used to set the default store properties
	 * If you're using a custom store, don't worry about this
	 */
	Model.storeProperties = {};
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.default = Model;
	//# sourceMappingURL=Model.js.map

/***/ },
/* 30 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || function (d, b) {
	    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
	    function __() { this.constructor = d; }
	    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	};
	var Api_1 = __webpack_require__(1);
	var Cache_1 = __webpack_require__(2);
	/**
	 * A Store is an Api that handles the requests for a given Model
	 */
	var Store = (function (_super) {
	    __extends(Store, _super);
	    function Store(model, properties) {
	        if (properties === void 0) { properties = {}; }
	        var _this = _super.call(this, properties) || this;
	        _this.model = model;
	        if (model && !model.store) {
	            model.store = _this;
	        }
	        return _this;
	    }
	    /**
	     * @inheritDoc
	     */
	    Store.prototype.path = function () {
	        return this.model.path;
	    };
	    /**
	     * Check if method is allowed
	     */
	    Store.prototype.isMethodAllowed = function (method) {
	        if (this.denies && this.denies.indexOf(method) !== -1) {
	            return false;
	        }
	        return !this.allows || this.allows.indexOf(method) !== -1;
	    };
	    /**
	     * Verify if a method can be executed. If it can't, throw an error
	     * @throws Error
	     */
	    Store.prototype.verifyPermission = function (method) {
	        if (!this.isMethodAllowed(method)) {
	            var message = "Method '" + method + "' is not allowed in '" + this.path() + "' store";
	            throw new Error(message);
	        }
	    };
	    /**
	     * Get new model instance
	     */
	    Store.prototype.make = function (values, normalize) {
	        if (normalize === void 0) { normalize = true; }
	        return this.model.make(values, normalize);
	    };
	    /**
	     * Get index
	     */
	    Store.prototype.index = function (options) {
	        var _this = this;
	        if (options === void 0) { options = {}; }
	        if (!options.permit) {
	            this.verifyPermission('index');
	        }
	        var url = options.url || '';
	        return this.cachePromise("index/" + url, function (resolve, reject) {
	            var list = _this.cache.getList("index/" + url);
	            if (!options.ignoreCache && list) {
	                if (list) {
	                    return resolve(list);
	                }
	            }
	            var promise = _this.http().get(url);
	            promise.then(function (response) {
	                var list = _this.make(response.data);
	                _this.cache.setList("index/" + url, list);
	                if (_this.setIndex) {
	                    _this.cache.set(list, false);
	                }
	                resolve(list);
	            }, reject);
	        });
	    };
	    /**
	     * Make http get request
	     */
	    Store.prototype.get = function (key, options) {
	        var _this = this;
	        if (options === void 0) { options = {}; }
	        if (!options.permit) {
	            this.verifyPermission('get');
	        }
	        key = Cache_1.default.resolveKey(key);
	        var url = options.url || key.toString();
	        return this.cachePromise("get/" + url, function (resolve, reject) {
	            if (!options.ignoreCache) {
	                var object = _this.cache.get(key);
	                if (object) {
	                    return resolve(object);
	                }
	            }
	            var promise = _this.http().get(url);
	            promise.then(function (response) {
	                var instance = _this.make(response.data);
	                resolve(_this.cache.set(instance, false));
	            }, reject);
	        });
	    };
	    /**
	     * Make http get request to fetch by property
	     */
	    Store.prototype.where = function (property, value, options) {
	        var _this = this;
	        if (options === void 0) { options = {}; }
	        if (!options.permit) {
	            this.verifyPermission('where');
	        }
	        var url = options.url;
	        if (!options.url) {
	            url = property + "/" + value;
	        }
	        return this.cachePromise("where/" + url, function (resolve, reject) {
	            if (!options.ignoreCache) {
	                var object = _this.cache.where(property, value);
	                if (object) {
	                    return resolve(object);
	                }
	            }
	            var promise = _this.http().get(url);
	            promise.then(function (response) {
	                var instance = _this.make(response.data);
	                resolve(_this.cache.set(instance, false));
	            }, reject);
	        });
	    };
	    /**
	     * Make http post request
	     */
	    Store.prototype.create = function (data, options) {
	        var _this = this;
	        if (options === void 0) { options = {}; }
	        this.verifyPermission('create');
	        var promise = this.http().post(options.url || '', data);
	        return new Promise(function (resolve, reject) {
	            promise.then(function (response) {
	                var instance = _this.make(response.data);
	                resolve(_this.cache.set(instance));
	            }, reject);
	        });
	    };
	    /**
	     * Make http put request
	     */
	    Store.prototype.update = function (data, options) {
	        var _this = this;
	        if (options === void 0) { options = {}; }
	        this.verifyPermission('update');
	        return new Promise(function (resolve, reject) {
	            var promise = _this.http().put(options.url || data[_this.model.keyColumn].toString(), data);
	            promise.then(function (response) {
	                var instance = _this.make(response.data);
	                resolve(_this.cache.set(instance));
	            }, reject);
	        });
	    };
	    /**
	     * Make http request to destroy model
	     */
	    Store.prototype.destroy = function (value, options) {
	        var _this = this;
	        if (options === void 0) { options = {}; }
	        this.verifyPermission('destroy');
	        var id = Cache_1.default.resolveKey(value);
	        var promise = this.http().delete(options.url || id);
	        promise.then(function () { return _this.cache.destroy(id); });
	        return promise;
	    };
	    /**
	     * Call foreign method of store associated with given model
	     */
	    Store.prototype.by = function (model, key, options) {
	        if (options === void 0) { options = {}; }
	        return model.resolveStore().foreign(this.model, key, options);
	    };
	    /**
	     * Make http request to fetch instances by foreign key
	     */
	    Store.prototype.foreign = function (model, key, options) {
	        var _this = this;
	        if (options === void 0) { options = {}; }
	        if (!options.permit) {
	            this.verifyPermission('foreign');
	        }
	        key = Cache_1.default.resolveKey(key);
	        var url = options.url || key + "/" + model.path;
	        return this.cachePromise("foreign/" + url, (function (resolve, reject) {
	            var list = _this.cache.getList(url);
	            if (!options.ignoreCache && list) {
	                return resolve(list);
	            }
	            _this.http().get(url).then(function (response) {
	                var list = _this.make(response.data);
	                _this.cache.setList(url, list);
	                if (options.set || (!Array.isArray(list) && options.set !== false)) {
	                    _this.cache.set(list, false);
	                }
	                resolve(list);
	            }, reject);
	        }));
	    };
	    /**
	     * Make http to act
	     */
	    Store.prototype.act = function (key, action, options) {
	        if (options === void 0) { options = {}; }
	        if (!options.permit) {
	            this.verifyPermission('act');
	        }
	        key = Cache_1.default.resolveKey(key);
	        var url = options.url || key + "/" + action;
	        var method = this.http()[options.method || 'put'];
	        return method(url, options.data);
	    };
	    return Store;
	}(Api_1.default));
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.default = Store;
	//# sourceMappingURL=Store.js.map

/***/ }
/******/ ])
});
;